using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;

namespace MemLeakProfileDemo
{

    public partial class Form1 : Form
    {
        private Fool fool;
        private FoolBrother brother;

        public Form1()
        {
            InitializeComponent();
            fool = new Fool();
            brother = new FoolBrother();
            //引用fool
            brother.YoungFool = fool;
        }

        private void btnException_Click(object sender, EventArgs e)
        {
            fool = null;
            // raise exception
            fool.AllocalHugeMem();
        }

        private void btnHang_Click(object sender, EventArgs e)
        {
            //start this thread and close window,application will not exit!
            Thread th = new System.Threading.Thread(new ThreadStart(this.DoWork));
            th.Name = "HangThread";
            th.Start();
        }

        private void DoWork()
        {
            while (true)
            {
                Thread.Sleep(1000);
            }
        }

        #region

        private void btnAlloc_Click(object sender, EventArgs e)
        {
            var i = 10;
            //AllocalHugeMem 会申请10M的内存
            fool.AllocalHugeMem();
        }

        private void btnWrongRelease_Click(object sender, EventArgs e)
        {
            //虽然fool 指向null,但 brother保留了对fool的引用,GC无效果.内存泄露
            fool = null;

            GCRelease();
        }

        private void btnRightRelease_Click(object sender, EventArgs e)
        {
            //消除 brother 对fool的引用,GC效果明显
            fool = null;
            brother = null;

            GCRelease();

        }

        private void GCRelease()
        {
            GC.Collect();
            GC.WaitForPendingFinalizers();
            GC.Collect();
        }
        #endregion
    }

    public class Fool
    {
        private IList<byte[]> list = new List<byte[]>();

        public void AllocalHugeMem()
        {
            var buffer = new byte[10 * 1024 * 1024];
            for (int i = 0; i < buffer.Length; i++)
            {
                buffer[i] = 1;
            }
            list.Add(buffer);
        }
    }

    public class FoolBrother
    {
        public Fool YoungFool
        {
            get;
            set;
        }
    }
}
